#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		if(p->access >= OP_Moderator)
		{sendPrivate(p,"-----AFK-Bot-----");}
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
				sendPrivate(p,"Bot-Sysop Commands: !afktime <#> !listexempt !afksavesetts");
				sendPrivate(p,"Bot-Sysop Commands: !addexempt <Player> !delexempt <Player>");
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
				sendPrivate(p,"Bot-Mod Commands: !afkstatus [on/off]");
				sendPrivate(p,"-----------------");
			}
			break;
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if(c->checkParam("afktime"))
			{
				sendPrivate(p,"Command !afktime #: Change the time limit that a player has before they are considered AFK");
			}
			else if(c->checkParam("addexempt"))
			{
				sendPrivate(p,"Command !addexempt <PlayerName>: Add a player\'s name to the list of players that are not checked for AFK");
			}
			else if(c->checkParam("delexempt"))
			{
				sendPrivate(p,"Command !delexempt <PlayerName>: Deleted a players\'s name from the list of exempt players");
			}
			else if(c->checkParam("listexempt"))
			{
				sendPrivate(p,"Command !listexempt: List the names of the players that are exempt from AFK checking");
			}
			else if(c->checkParam("afksavesetts"))
			{
				sendPrivate(p,"Command !afksavesetts: Save all of the settings of the bot into its file!");
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->checkParam("afkstatus"))
			{
				sendPrivate(p,"Command !afkstatus [on/off]: Turn on or off the AFK checking status");
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if(c->check("afktime"))
			{
				String Time=c->final;
				String Message;

				if(!Time.IsEmpty())
				{
					if(isNumeric(Time.msg))
					{
						AfkTime=Time.toInteger();
						Message= "AFK Time Limit Changed to ";
						Message+=AfkTime;
						Message+= " Mins";
					}
					else
					{Message= "You must specify a number! Format- !afktime #";}
				}
				else
				{
					Message= "AFK Time Limit: ";
					if(AfkTime > 0)
					{
						Message+= AfkTime;
						Message+= " Mins";
					}
					else
					{Message+= "Not Yet Set";}
				}
				sendPrivate(p,Message);
			}
			else if(c->check("addexempt"))
			{
				String PlayerName= c->final;
				String Message;

				if(!PlayerName.IsEmpty())
				{
					for(_listnode <Exempt> *el=ExemptList.head;el;el=el->next)
					{
						if(CMPSTR(PlayerName,el->item->name))
						{break;}
					}

					if(el == NULL)
					{
						DelPlayer(PlayerName.msg);	
						ExemptList.append(new Exempt(PlayerName));
						Message=PlayerName;
						Message+=" Added Successfully!";
					}
					else
					{Message= "That player has already been recorded on the AFK exempt list!";}
				}
				else
				{Message="You must specify a player\'s name. Format- !addexempt <PlayerName>";}
				sendPrivate(p,Message);
			}
			else if(c->check("delexempt"))
			{
				String PlayerName= c->final;
				String Message;

				if(!PlayerName.IsEmpty())
				{
					for(_listnode <Exempt> *el=ExemptList.head;el;el=el->next)
					{
						if(CMPSTR(PlayerName,el->item->name))
						{
							ExemptList.kill(el);
							for(_listnode <Player> *pl=playerlist->head;pl;pl=pl->next)
							{
								if(CMPSTR(PlayerName,pl->item->name))
								{
									if(pl->item->ship != 8)
									{AddPlayer(pl->item);}
									break;
								}
							}
							Message=PlayerName;
							Message+=" Deleted Successfully!";
							break;
						}
					}

					if(el == NULL)
					{Message= "That player was not found on the AFK exempt list";}
				}
				else
				{
					Message="You must specify a player\'s name. Format- !delexempt <PlayerName>";
				}
				sendPrivate(p,Message);
			}
			else if(c->check("listexempt"))
			{
				if(ExemptList.total > 0)
				{
					String Lines=   "|-----------------------------|";
					String Message= "|    Player Exemption List    |";
					sendPrivate(p,Lines);
					sendPrivate(p,Message);
					sendPrivate(p,Lines);
	
					for(_listnode <Exempt> *el= ExemptList.head;el;el=el->next)
					{
						Message="| Player: ";
						Message+= el->item->name;
						while(Message.len < Lines.len-1)
						{
							Message+=" ";
						}
						Message+= "|";
						sendPrivate(p,Message);
					}
					sendPrivate(p,Lines);
				}
				else
				{sendPrivate(p,"No players are currently exempt from the AFK List");}
			}
			else if(c->check("afksavesetts"))
			{
				char Path[512]; //file path
				GetCurrentDirectory(512, Path); //grab the path
				strcat(Path, "\\AFK-Bot.ini"); //append the file name

				remove(Path);
				WritePrivateProfileString("Settings", "Enabled", getString(Enabled, 2, 0, true), Path); 
				WritePrivateProfileString("Settings", "AfkTime", getString(AfkTime, 10, 0, true), Path);

				String S;
				Uint16 i=1;
				for(_listnode <Exempt> *el=ExemptList.head;el;el=el->next)
				{
					S="Name";
					S+=i++;
					WritePrivateProfileString("Exemptions", S.msg, el->item->name, Path);
				}
				sendPrivate(p,"AFK-Bot: Save Complete");
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->check("afkstatus"))
			{
				String Status= c->final; //get final portion of string

				if(Status.IsEmpty()) //if its empty
				{
					Status= "AFK Checking Status: ";
					if(Enabled)
					{Status+= "ON";}
					else
					{Status+= "OFF";}		
				}
				else //if the string has a command in it
				{
					if(Status == "on") //if the command was on
					{
						//then enable the bot
						if(Enabled)
						{Status= "AFK Checking Is Already Enabled";}
						else
						{
							if(AfkTime > 0)
							{
								AFKList.clear();
								Enabled =true;
								Status= "AFK Checking Turned ON Successfully";
								for(_listnode <Player> *pl=playerlist->head;pl;pl=pl->next)
								{
									if(pl->item->ship != 8)
									{
										AddPlayer(pl->item);
									}
								}
							}
							else
							{Status= "A Bot-Sysop must set a value for !afktime before this bot can be activated!";}

						}
					}
					else //if the command was off
					{
						if(Status == "off")//then disable the bot
						{
							if(Enabled)
							{	
								Enabled=false;
								AFKList.clear();
								Status= "AFK Checking Turned OFF Successfully";
							}
							else
							{Status= "AFK Checking Is Already Disabled";}
						}
						else //if it wasnt a On or OFF command, then it was invalid
						{Status= "Invalid command for !afkstatus , use ON or OFF. Ex- !afkstatus on";}
					}
				}
				sendPrivate(p,Status);
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if (c->check("about") || c->check("version"))
			{
				sendPrivate(p, "AFK Spec\'n Behavior v1 by 50% Packetloss(FiftyPacketloss@socal.rr.com)");
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
